-- minimal example application for Moonbridge
-- invoke with ./moonbridge helloworld.lua
--
-- see example_application.lua for a more elaborated example

local http = require "moonbridge_http"

listen{
  { proto = "tcp4", port = 8080, localhost = true },
  { proto = "tcp6", port = 8080, localhost = true },
  connect = http.generate_handler(
    function(request)
      local function error_response(status)
        request:send_status(status)
        request:send_header("Content-Type", "text/html")
        request:send_data("<html>\n<head><title>", status, "</title></head>\n<body><h1>", status, "</h1></body>\n</html>\n")
      end
      if request.method == "GET" or request.method == "HEAD" then
        if request.path == "" then
          request:send_status("200 OK")
          request:send_header("Content-Type", "text/html; charset=UTF-8")
          request:send_data("<html>\n<head><title>Hello World Application</title></head>\n<body>Hello World!</body>\n</html>\n")
        else
          error_response("404 Not Found")
        end
      else
        error_response("405 Method not allowed")
      end
      return true
    end
  )
}

